## scons 4.0.1%2Bdfsg

=== test/MSVC/VSWHERE-fixture/SConstruct ===
import os
import os.path

from SCons.Tool.MSCommon.vc import VSWHERE_PATHS

# Dump out expected paths
for vw_path in VSWHERE_PATHS:
    print("VSWHERE_PATH=%s"%vw_path)


# Allow normal detection logic to find vswhere.exe
env1=Environment()
print("VSWHERE-detect=%s" % env1['VSWHERE'])

# Copy found vswhere.exe to current dir
v_local = os.path.join(os.getcwd(), 'vswhere.exe')
Execute(Copy(os.path.join(os.getcwd(), 'vswhere.exe'), env1['VSWHERE']))

# With VSWHERE set to copied vswhere.exe (see above), find vswhere.exe
env=Environment(VSWHERE=v_local)
print("VSWHERE-env=%s" % env['VSWHERE'])

=== test/TaskMaster/bug_2811/fixture_dir/SConstruct ===
"""
This issue requires the following.
1. Generated source file which outputs 2 (or more) files
2. Action string gets scanned providing only compiler as part of implicit scan
3. Generated file gets built. Without the bugfix only the first target's .implicit list is cleared.
4. builder/executor/action gets tried again and implicits scanned. 2nd to Nth targets end up 
   with the compiler at the beginning of the implicit list and the rest of the scanned files added to that list.
5. That bimplicit gets saved into sconsign
6. Second run loads sconsign, now with generated file present a regular implicit scan occurs. This yields 2nd through
   Nth target's implicit lists changing when compared to SConsign's which have been loaded.
7. This forces rebuild of source file and this propagates to massive recompile
"""
import sys
import SCons.Tool


def _dwo_emitter(target, source, env):
    new_targets = []
    for t in target:
        base, ext = SCons.Util.splitext(str(t))
        if not any(ext == env[osuffix] for osuffix in ['OBJSUFFIX', 'SHOBJSUFFIX']):
            continue
        # TODO: Move 'dwo' into DWOSUFFIX so it can be customized? For
        # now, GCC doesn't let you control the output filename, so it
        # doesn't matter.
        dwotarget = (t.builder.target_factory or env.File)(base + ".dwo")
        new_targets.append(dwotarget)
    targets = target + new_targets
    return (targets, source)

build_string = '$MYCOPY $SOURCE $TARGET'


bld = Builder(action=build_string)

env = Environment(BUILDERS={'Foo': bld}, MYCOPY="%s mycopy.py"%sys.executable)

env['SHCCCOM'] = '$MYCOPY $SOURCE $TARGET && $MYCOPY $SOURCE ${TARGETS[1]}'

env['SHCCCOMSTR'] = env['SHCCCOM']


suffixes = ['.c']

for object_builder in SCons.Tool.createObjBuilders(env):
    emitterdict = object_builder.builder.emitter
    for suffix in emitterdict.keys():
        if not suffix in suffixes:
            continue
        base = emitterdict[suffix]
        emitterdict[suffix] = SCons.Builder.ListEmitter([
            base,
            _dwo_emitter,
        ])

vs = ['a']

for v in vs:
    env.Foo('%s.c' % v, v)
    env.SharedObject('%s.c'%v)

env.Foo('b','b.in')
# seems like processing is always alphabetical..


# code: language=python insertSpaces=4 tabSize=4

=== test/Docbook/basic/xslt/image/SConstruct ===
import os

env = Environment(tools=['docbook'])

#
# Create document
#
env.DocbookXslt('out.xml', 'in.xml', 
                xsl='./to_docbook.xslt')

## scons 4.0.1+dfsg

=== SConstruct ===
#
# SConstruct file to build scons packages during development.
#
# See the README.rst file for an overview of how SCons is built and tested.
import os.path
import sys
import textwrap
from time import strftime

copyright_years = strftime('2001 - %Y')

# This gets inserted into the man pages to reflect the month of release.
month_year = strftime('%B %Y')
#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#


project = 'scons'
default_version = '4.0.1'
copyright = "Copyright (c) %s The SCons Foundation" % copyright_years

#
# We let the presence or absence of various utilities determine whether
# or not we bother to build certain pieces of things.  This should allow
# people to still do SCons packaging work even if they don't have all
# of the utilities installed
#
print("git    :%s" % git)
print("gzip   :%s" % gzip)
print("unzip  :%s" % unzip)
print("zip    :%s" % zip_path)

#
# Adding some paths to sys.path, this is mainly needed
# for the doc toolchain.
#
addpaths = [os.path.abspath(os.path.join(os.getcwd(), 'bin')),
            os.path.abspath(os.path.join(os.getcwd(), 'testing/framework'))]
for a in addpaths:
    if a not in sys.path:
        sys.path.append(a)

# Use site_scons logic to process command line arguments
command_line = BuildCommandLine(default_version)
command_line.process_command_line_vars()

Default('.', command_line.build_dir)
# Just make copies, don't symlink them.
SetOption('duplicate', 'copy')

packaging_flavors = [
    ('tar-gz', "The normal .tar.gz file for end-user installation."),
    ('local-tar-gz', "A .tar.gz file for dropping into other software " +
     "for local use."),
    ('zip', "The normal .zip file for end-user installation."),
    ('local-zip', "A .zip file for dropping into other software " +
     "for local use."),
    ('src-tar-gz', "A .tar.gz file containing all the source " +
     "(including tests and documentation)."),
    ('src-zip', "A .zip file containing all the source " +
     "(including tests and documentation)."),
]

test_tar_gz_dir = os.path.join(command_line.build_dir, "test-tar-gz")
test_src_tar_gz_dir = os.path.join(command_line.build_dir, "test-src-tar-gz")
test_local_tar_gz_dir = os.path.join(command_line.build_dir, "test-local-tar-gz")
test_zip_dir = os.path.join(command_line.build_dir, "test-zip")
test_src_zip_dir = os.path.join(command_line.build_dir, "test-src-zip")
test_local_zip_dir = os.path.join(command_line.build_dir, "test-local-zip")

unpack_tar_gz_dir = os.path.join(command_line.build_dir, "unpack-tar-gz")
unpack_zip_dir = os.path.join(command_line.build_dir, "unpack-zip")

if is_windows():
    tar_hflag = ''
#     python_project_subinst_dir = os.path.join("Lib", "site-packages", project)
#     project_script_subinst_dir = 'Scripts'
else:
    tar_hflag = 'h'
#     python_project_subinst_dir = os.path.join("lib", project)
#     project_script_subinst_dir = 'bin'

indent_fmt = '  %-26s  '

Help("""\
The following aliases build packages of various types, and unpack the
contents into build/test-$PACKAGE subdirectories, which can be used by the
runtest.py -p option to run tests against what's been actually packaged:

""")

aliases = sorted(packaging_flavors + [('doc', 'The SCons documentation.')])

for alias, help_text in aliases:
    tw = textwrap.TextWrapper(
        width=78,
        initial_indent=indent_fmt % alias,
        subsequent_indent=indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

Help("""
The following command-line variables can be set:

""")

for variable, help_text in command_line.command_line_variables:
    tw = textwrap.TextWrapper(
        width=78,
        initial_indent=indent_fmt % variable,
        subsequent_indent=indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

revaction = SCons_revision
revbuilder = Builder(action=Action(SCons_revision,
                                   varlist=['COPYRIGHT', 'VERSION']))

env = Environment(
    ENV=command_line.ENV,

    BUILD=command_line.build_id,
    BUILDDIR=command_line.build_dir,
    BUILDSYS=command_line.build_system,
    COPYRIGHT=copyright,
    DATE=command_line.date,
    DEB_DATE=deb_date,

    DEVELOPER=command_line.developer,
    DISTDIR=os.path.join(command_line.build_dir, 'dist'),
    MONTH_YEAR=month_year,
    REVISION=command_line.revision,
    VERSION=command_line.version,

    TAR_HFLAG=tar_hflag,

    ZIP=zip_path,
    ZIPFLAGS='-r',
    UNZIP=unzip,
    UNZIPFLAGS='-o -d $UNPACK_ZIP_DIR',

    # ZCAT=zcat,
    # ZIPID=zipit,

    TEST_SRC_TAR_GZ_DIR=test_src_tar_gz_dir,
    TEST_SRC_ZIP_DIR=test_src_zip_dir,
    TEST_TAR_GZ_DIR=test_tar_gz_dir,
    TEST_ZIP_DIR=test_zip_dir,

    UNPACK_TAR_GZ_DIR=unpack_tar_gz_dir,
    UNPACK_ZIP_DIR=unpack_zip_dir,

    BUILDERS={'SCons_revision': revbuilder,
              'SOElim': soelimbuilder},

    PYTHON='"%s"' % sys.executable,
    PYTHONFLAGS='-tt',
)

Version_values = [Value(command_line.version), Value(command_line.build_id)]

installed_local_files = create_local_packages(env)

update_init_file(env)
#
#
#
#
# Documentation.
#
Export('command_line', 'env', 'whereis', 'revaction')

SConscript('doc/SConscript')


# Build packages for pypi
env.Command('$DISTDIR/SCons-${VERSION}-py3-none-any.whl', ['setup.cfg', 'setup.py', 'SCons/__init__.py'],
            '$PYTHON setup.py bdist_wheel')

env.Command('$DISTDIR/SCons-${VERSION}.zip', ['setup.cfg', 'setup.py', 'SCons/__init__.py'],
            '$PYTHON setup.py sdist --format=zip')
env.Command('$DISTDIR/SCons-${VERSION}.tar.gz', ['setup.cfg', 'setup.py', 'SCons/__init__.py'],
            '$PYTHON setup.py sdist --format=gztar')

# TODO add auto copyright date to README.rst, LICENSE
# TODO build API DOCS

=== requirements.txt ===
# Packages needed for development, packaging, and distribution, but not for running SCons

# This will check if the README.rst will render o.k. on pypi and not block an upload
# Can be used with twinecheck
# See: https://github.com/pypa/readme_renderer
readme-renderer
sphinx
sphinx_rtd_theme
lxml==4.5.0
rst2pdf

=== test/Actions/unicode-signature-fixture/SConstruct ===
fnode = File(u'foo.txt')

def funcact(target, source, env):
    with open(str(target[0]), 'wb') as f:
        f.write(b"funcact\n")
    for i in range(300):
        pass
    return 0

env = Environment()

env.Command(fnode, [], ["echo $TARGET", funcact])

=== test/CacheDir/value_dependencies/SConstruct ===
import SCons.Node

CacheDir('cache')

def b(target, source, env):
	with open(target[0].abspath, 'w') as f:
		pass

def scan(node, env, path):
    # Have the node depend on a directory, which depends on an instance of
    # SCons.Node.Python.Value.
    sample_dir = env.fs.Dir('dir2')
    env.Depends(sample_dir, env.Value('c'))
    return [sample_dir, env.Value('d'), env.Value(b'\x03\x0F', name='name3')]

scanner = Scanner(function=scan, node_class=SCons.Node.Node)
builder = Builder(action=b, source_scanner=scanner)

env = Environment()
env.Append(BUILDERS={'B': builder})

# Create a node and a directory that each depend on an instance of
# SCons.Node.Python.Value.
sample_dir = env.fs.Dir('dir1')
env.Depends(sample_dir,
            [env.Value('a'), env.Value(b'\x01\x0F', name='name1')])

sample_file = env.fs.File('testfile')
env.Depends(sample_file,
            [env.Value('b'), env.Value(b'\x02\x0F', name='name2')])

env.B(target='File1.out', source=[sample_dir, sample_file])

=== test/CompilationDatabase/fixture/SConstruct ===
import sys

DefaultEnvironment(tools=[])
env = Environment(
    PYTHON=sys.executable,
    LINK='$PYTHON mylink.py',
    LINKFLAGS=[],
    CC='$PYTHON mygcc.py cc',
    CXX='$PYTHON mygcc.py c++',
    tools=['gcc','g++','gnulink'],
)
env.Tool('compilation_db')

env_abs = env.Clone(COMPILATIONDB_USE_ABSPATH=True)
env_abs.CompilationDatabase('compile_commands_clone_abs.json')

# Should be relative paths
env.CompilationDatabase('compile_commands_only_arg.json')
env.CompilationDatabase(target='compile_commands_target.json')

# Should default name compile_commands.json
env.CompilationDatabase()

# Should be absolute paths
env.CompilationDatabase('compile_commands_over_abs.json', COMPILATIONDB_USE_ABSPATH=True)
env.CompilationDatabase(target='compile_commands_target_over_abs.json', COMPILATIONDB_USE_ABSPATH=True)

# Should be relative paths
env.CompilationDatabase('compile_commands_over_rel.json', COMPILATIONDB_USE_ABSPATH=False)

# Try 1/0 for COMPILATIONDB_USE_ABSPATH
env.CompilationDatabase('compile_commands_over_abs_1.json', COMPILATIONDB_USE_ABSPATH=1)
env.CompilationDatabase('compile_commands_over_abs_0.json', COMPILATIONDB_USE_ABSPATH=0)

env.Program('main', 'test_main.c')

=== test/Decider/MD5-winonly-fixture/SConstruct ===
DefaultEnvironment(tools=[])
env=Environment()
env.Decider('MD5-timestamp')
env.AppendENVPath('PATH', r'd:\mesa\flexbison')
env.Tool('lex')
env.Tool('yacc')
env['YACCFLAGS'] = '-d'
if env['YACC'] == 'win_flex':
    env.Append(LEXFLAGS = ['--wincompat'])
env.SharedLibrary('dummy',['test_lex.l','test_parse.y'])

=== test/Dir/DriveAbsPath/SConstruct ===
import os
import SCons

env = Environment()
drive = os.path.splitdrive(os.getcwd())[0]
drive_dir = env.fs.Dir(drive)

if not isinstance(drive_dir, SCons.Node.FS.RootDir):
	raise Exception('env.fs.Dir("%s") returned a %s instead of a RootDir' %
					(drive, type(drive_dir)))

drive_abspath1 = drive_dir._abspath
drive_abspath2 = drive_dir.abspath
if drive_abspath1 != drive_abspath2:
	raise Exception('Calculated _abspath %s is not the same as abspath %s' %
					(drive_abspath1, drive_abspath2))
elif not os.path.exists(drive_abspath1):
	raise Exception('Calculated abspath %s does not exist' % drive_abspath1)
elif drive.rstrip(os.path.sep) != drive_abspath1.rstrip(os.path.sep):
	raise Exception('Real drive %s and calculated abspath %s are not the '
					'same' % (drive, drive_abspath1))

drive_path1 = drive_dir._path
drive_path2 = drive_dir.path
if drive_path1 != drive_path2:
	raise Exception('Calculated _path %s is not the same as path %s' %
					(drive_path1, drive_path2))
elif not os.path.exists(drive_path1):
	raise Exception('Calculated path %s does not exist' % drive_path1)
elif drive.rstrip(os.path.sep) != drive_path1.rstrip(os.path.sep):
	raise Exception('Real drive %s and calculated abspath %s are not the '
					'same' % (drive, drive_abs))

=== test/MinGW/bug_2799/SConstruct ===
env = Environment(
        tools = ['mingw'],
        SHCCCOMSTR = 'SHCC $TARGET',
        SHLINKCOMSTR = 'SHLINK $TARGET',
        LDMODULECOMSTR = 'LDMODULE $TARGET',
        SHOBSUFFIX='.o',
        SHLIBSUFFIX='.so',
        SHLIBPREFIX='lib',
        LDMODULESUFFIX='.so',
)

env.SharedLibrary('testlib', 'shlib.c')

env.LoadableModule('testmodule', 'module.c')

=== test/textfile/fixture/SConstruct ===
DefaultEnvironment(tools=[])


env = Environment(tools=['textfile'])
data0 = ['Goethe', 'Schiller']
data = ['lalala', 42, data0, 'tanteratei']

env.Textfile('foo1', data)
env.Textfile('foo2', data, LINESEPARATOR='|*')
env.Textfile('foo1a.txt', data + [''])
env.Textfile('foo2a.txt', data + [''], LINESEPARATOR='|*')

# recreate the list with the data wrapped in Value()
data0 = list(map(Value, data0))
data = list(map(Value, data))
data[2] = data0

env.Substfile('bar1', data)
env.Substfile('bar2', data, LINESEPARATOR='|*')
data.append(Value(''))
env.Substfile('bar1a.txt', data)
env.Substfile('bar2a.txt', data, LINESEPARATOR='|*')

=== test/D/MixedDAndC/Image/SConstruct ===
# -*- mode:python; coding:utf-8; -*-

import os

environment = Environment(
)
#    CFLAGS=['-m64'],
#    DLINKFLAGS=['-m64'],
#    DFLAGS=['-m64', '-O'])

environment.Program('proj', [
'proj.d',
'dmod.d',
'cmod.c',
])

=== test/Install/multi-dir/src/SConstruct ===
# This tests for a bug where installing a sequence dirs and subdirs
# outside the source tree can cause SCons to fail to create the dest
# dir.
import os, os.path, shutil
DefaultEnvironment(tools=[])
env=Environment(tools=[])
dst='../build'
env.Install(os.path.join(dst,'__foo/bar/baz'), 'a')
env.Install(os.path.join(dst,'__foo/bar/baz/a/b'), 'x/y')

=== test/packaging/convenience-functions/image/SConstruct ===
env  = Environment(tools=['default', 'packaging'])
prog = env.Install( 'bin/', ["f1", "f2"] )
env.File( "f3" )

src_files = sorted(map(str, env.FindSourceFiles()))
oth_files = sorted(map(str, env.FindInstalledFiles()))

print(src_files)
print(oth_files)

=== debian/changelog ===
scons (4.0.1+dfsg-2mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 05 Nov 2022 21:35:23 -0700

scons (4.0.1+dfsg-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 27 Oct 2020 18:38:13 +0100

scons (4.0.1+dfsg-1) experimental; urgency=medium

  * New major upstream release.
  * Merge in scons-doc package (closes: #968655).
  * Remove Jörg from being a maintainer, thanks for all the fish.
  * Be the primary maintainer (closes: #968654).
  * Rework packaging.
  * Update watch file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 23 Aug 2020 20:25:23 +0200

=== debian/control ===
Source: scons
Section: devel
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 python3-all (>= 3.5),
 fop,
 python3-lxml,
 python3-setuptools,
 biber <!nocheck>,
 clang <!nocheck>,
 gdc <!nocheck>,
 ldc [amd64] <!nocheck>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.scons.org/
Vcs-Git: https://salsa.debian.org/debian/scons.git
Vcs-Browser: https://salsa.debian.org/debian/scons

Package: scons
Architecture: all
Depends:
 ${python3:Depends},
 ${misc:Depends}
Description: replacement for make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.

Package: scons-doc
Architecture: all
Depends: ${misc:Depends}
Breaks: scons-doc (<< 4.0.1)
Replaces: scons-doc (<< 4.0.1)
Suggests: scons (>= 4.0)
Description: Documentation for SCons, a replacement for Make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.
 .
 This package provides the SCons User's guide.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SCONS_FLAGS := $(subst parallel=,-j ,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

%:
	dh $@ --with python3

override_dh_auto_configure:
	@:

override_dh_auto_build:
	cd $(CURDIR)/doc/man && python3 ../../scripts/scons.py
	cd $(CURDIR)/doc/user && python3 ../../scripts/scons.py

override_dh_auto_install:
	python3 setup.py install --prefix /usr --root '$(CURDIR)/debian/scons'
	$(RM) -r debian/scons/usr/lib/python*/site-packages/SCons/Tool/docbook/

override_dh_auto_clean:
	$(RM) -r .sconsign.dblite bootstrap build $$(find * -name __pycache__ -type d)
	$(RM) -r $(CURDIR)/SCons.egg-info $(CURDIR)/.pybuild
	# generated documentation
	$(RM) $(CURDIR)/doc/man/.sconsign.dblite
	$(RM) $(CURDIR)/doc/man/mimetype
	$(RM) $(CURDIR)/doc/man/*.1
	$(RM) $(CURDIR)/doc/man/*.epub
	$(RM) $(CURDIR)/doc/man/*.fo
	$(RM) $(CURDIR)/doc/man/*.html
	$(RM) $(CURDIR)/doc/man/*.pdf
	$(RM) $(CURDIR)/doc/man/scons-time_db.xml
	$(RM) $(CURDIR)/doc/man/scons-time_xi.xml
	$(RM) $(CURDIR)/doc/man/scons_db.xml
	$(RM) $(CURDIR)/doc/man/scons_xi.xml
	$(RM) $(CURDIR)/doc/man/sconsign_db.xml
	$(RM) $(CURDIR)/doc/man/sconsign_xi.xml
	$(RM) $(CURDIR)/doc/user/.sconsign.dblite
	$(RM) $(CURDIR)/doc/user/mimetype
	$(RM) $(CURDIR)/doc/user/*.epub
	$(RM) $(CURDIR)/doc/user/*.fo
	$(RM) $(CURDIR)/doc/user/*.html
	$(RM) $(CURDIR)/doc/user/*.pdf
	$(RM) $(CURDIR)/doc/user/scons_db.xml
	$(RM) $(CURDIR)/doc/user/scons_ex.xml
	$(RM) $(CURDIR)/doc/user/scons_exi.xml
	$(RM) $(CURDIR)/doc/user/scons_xi.xml
	$(RM) -r $(CURDIR)/doc/man/META-INF/
	$(RM) -r $(CURDIR)/doc/man/OEBPS/
	$(RM) -r $(CURDIR)/doc/user/META-INF/
	$(RM) -r $(CURDIR)/doc/user/OEBPS/
	$(RM) -r $(CURDIR)/doc/user/scons-user/

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.txt

override_dh_installdocs:
	dh_installdocs
	# organize files
	mv $(CURDIR)/debian/scons-doc/usr/share/doc/scons/scons-user/ \
		$(CURDIR)/debian/scons-doc/usr/share/doc/scons/HTML
	mv $(CURDIR)/debian/scons-doc/usr/share/doc/scons/scons.css \
		$(CURDIR)/debian/scons-doc/usr/share/doc/scons/HTML/
	mkdir $(CURDIR)/debian/scons-doc/usr/share/doc/scons/PDF
	mv $(CURDIR)/debian/scons-doc/usr/share/doc/scons/scons-user.pdf \
		$(CURDIR)/debian/scons-doc/usr/share/doc/scons/PDF

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	python3 runtest.py --all --passed $(SCONS_FLAGS) || true
endif

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## scons 4.4.0%2Bdfsg

=== doc/user/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook','gs','zip'], 
                  toolpath=['../../SCons/Tool'],
                  # DOCBOOK_XSLTPROCFLAGS="--stringparam  fop.extensions  1",
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# UserGuide for SCons
#
env.DocbookXInclude('scons_xi.xml', 'main.xml')
env.DocbookXslt('scons_ex.xml', 'scons_xi.xml', 
                xsl='../xslt/xinclude_examples.xslt')
env.DocbookXInclude('scons_exi.xml', 'scons_ex.xml')
env.DocbookXslt('scons_db.xml', 'scons_exi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html','scons_db.xml')
env.DocbookHtmlChunked('index.html', 'scons_db.xml', base_dir='scons-user/')
if has_pdf:
    env.DocbookPdf('scons-user.pdf','scons_db.xml')

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs('OEBPS/cover.jpg','scons-user.pdf', 
                 GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q')
    epub = env.DocbookEpub('scons-user.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== test/Actions/subst_shell_env-fixture/SConstruct ===
import sys

def custom_environment_expansion1(env, target, source, shell_env):
    ENV = shell_env.copy()
    ENV['EXPANDED_SHELL_VAR1'] = env.subst(env['ENV']['EXPANDED_SHELL_VAR1'], target=target, source=source)
    return ENV

def custom_environment_expansion2(env, target, source, shell_env):
    ENV = shell_env.copy()
    ENV['EXPANDED_SHELL_VAR2'] = env.subst(env['ENV']['EXPANDED_SHELL_VAR2'], target=target, source=source)
    return ENV

def expand_this_generator(env, target, source, for_signature):
    return "I_got_expanded_to_" + str(target[0])

def expand_that_generator(env, target, source, for_signature):
    return str(target[0]) + "_is_from_expansion"

env = Environment(tools=['textfile'])

env['SHELL_ENV_GENERATORS'] = [custom_environment_expansion1, custom_environment_expansion2]

env['EXPAND_THIS'] = expand_this_generator
env['EXPAND_THAT'] = expand_that_generator

env['ENV']['EXPANDED_SHELL_VAR1'] = "$EXPAND_THIS"
env['ENV']['EXPANDED_SHELL_VAR2'] = "$EXPAND_THAT"
env['ENV']['NON_EXPANDED_SHELL_VAR'] = "$EXPAND_THIS"

env.Textfile('expand_script.py', [
    'import os',
    'print(os.environ["EXPANDED_SHELL_VAR1"])',
    'print(os.environ["EXPANDED_SHELL_VAR2"])',
    'print(os.environ["NON_EXPANDED_SHELL_VAR"])',
])
env.Command('out.txt', 'expand_script.py', fr'{sys.executable} $SOURCE > $TARGET')

env.Depends('out.txt', env.Command('out2.txt', 'expand_script.py', fr'{sys.executable} $SOURCE > $TARGET'))

=== test/Configure/issue-3469/fixture/SConstruct ===
"""
This tests if we add/remove a test in between other tests if a rerun will properly cache the results.
Github issue #3469
"""

DefaultEnvironment(tools=[])

vars = Variables()
vars.Add(BoolVariable('SKIP', 'Skip Middle Conf test', 0))
env = Environment(variables=vars)

conf = Configure(env)
if not conf.CheckCHeader('math.h'):
    print('Math.h must be installed!')
    Exit(1)

if not env['SKIP'] and not conf.CheckCHeader('stdlib.h'):
    print('stdlib.h must be installed!')
    Exit(1)

if not conf.CheckCHeader('stdio.h'):
    print('stdio.h must be installed!')
    Exit(1)

env = conf.Finish()

## scons 4.4.0+dfsg

=== SConstruct ===
--- 
+++ 
@@ -12,7 +12,9 @@
 # This gets inserted into the man pages to reflect the month of release.
 month_year = strftime('%B %Y')
 #
-# __COPYRIGHT__
+# MIT License
+#
+# Copyright The SCons Foundation
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the
@@ -36,7 +38,7 @@
 
 
 project = 'scons'
-default_version = '4.0.1'
+default_version = '4.4.0'
 copyright = "Copyright (c) %s The SCons Foundation" % copyright_years
 
 #
@@ -142,6 +144,7 @@
     BUILD=command_line.build_id,
     BUILDDIR=command_line.build_dir,
     BUILDSYS=command_line.build_system,
+    COPYRIGHT_YEARS=copyright_years,
     COPYRIGHT=copyright,
     DATE=command_line.date,
     DEB_DATE=deb_date,
@@ -193,14 +196,25 @@
 SConscript('doc/SConscript')
 
 
+# Copy manpage's into base dir for inclusion in pypi packages
+man_pages = env.Install("#/", Glob("#/build/doc/man/*.1"))
+
 # Build packages for pypi
-env.Command('$DISTDIR/SCons-${VERSION}-py3-none-any.whl', ['setup.cfg', 'setup.py', 'SCons/__init__.py'],
+wheel = env.Command('$DISTDIR/SCons-${VERSION}-py3-none-any.whl', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
             '$PYTHON setup.py bdist_wheel')
 
-env.Command('$DISTDIR/SCons-${VERSION}.zip', ['setup.cfg', 'setup.py', 'SCons/__init__.py'],
+zip_file = env.Command('$DISTDIR/SCons-${VERSION}.zip', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
             '$PYTHON setup.py sdist --format=zip')
-env.Command('$DISTDIR/SCons-${VERSION}.tar.gz', ['setup.cfg', 'setup.py', 'SCons/__init__.py'],
+tgz_file = env.Command('$DISTDIR/SCons-${VERSION}.tar.gz', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
             '$PYTHON setup.py sdist --format=gztar')
+
+# Now set depends so the above run in a particular order
+env.Depends(tgz_file, [zip_file, wheel])
+
+# NOTE: Commenting this out as the manpages are expected to be in the base directory when manually
+# running setup.py from the base of the repo.
+# NOTE: This used by distro package maintainers.
+# env.AddPostAction(tgz_file, Delete(man_pages))
 
 # TODO add auto copyright date to README.rst, LICENSE
 # TODO build API DOCS

=== requirements.txt ===
--- 
+++ 
@@ -4,7 +4,16 @@
 # Can be used with twinecheck
 # See: https://github.com/pypa/readme_renderer
 readme-renderer
-sphinx
+#sphinx<=5.0.0
+sphinx>=5.1.1
 sphinx_rtd_theme
-lxml==4.5.0
 rst2pdf
+# for now keep pinning "known working" lxml,
+# it's been a troublesome component in the past.
+lxml==4.9.1
+rst2pdf
+ninja
+
+# Needed for test/Parallel/failed-build/failed-build.py
+# Also for test/ninja/shutdown_scons_daemon.py
+psutil

=== doc/developer/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../SCons/Tool'])

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('developer_xi.xml', 'main.xml')
env.DocbookXslt('developer.xml', 'developer_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('developer.html','developer.xml')
if has_pdf:
    env.DocbookPdf('developer.pdf','developer.xml')

=== doc/reference/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('reference_xi.xml', 'main.xml')
env.DocbookXslt('reference.xml', 'reference_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html','reference.xml')
env.DocbookHtmlChunked('index.html', 'reference.xml', base_dir='scons-reference/')
if has_pdf:
    env.DocbookPdf('scons-reference.pdf','reference.xml')

=== test/CacheDir/CACHEDIR_CLASS_fixture/SConstruct ===
import SCons
class CustomCacheDir(SCons.CacheDir.CacheDir):

    @classmethod
    def copy_to_cache(cls, env, src, dst):
        print("MY_CUSTOM_CACHEDIR_CLASS")
        super().copy_to_cache(env, src, dst)

env = Environment(tools=[])
env['CACHEDIR_CLASS'] = CustomCacheDir
env.CacheDir('cache')
env.Command('file.out', 'file.in', Copy('$TARGET', '$SOURCE'))

=== test/CacheDir/custom_cachedir_fixture/SConstruct ===
import SCons
class CustomCacheDir(SCons.CacheDir.CacheDir):

    @classmethod
    def copy_to_cache(cls, env, src, dst):
        print("MY_CUSTOM_CACHEDIR_CLASS")
        super().copy_to_cache(env, src, dst)

env = Environment(tools=[])
env.CacheDir('cache', CustomCacheDir)
env.Command('file.out', 'file.in', Copy('$TARGET', '$SOURCE'))

=== test/CacheDir/double_cachedir_fixture/SConstruct ===
import SCons
class CustomCacheDir1(SCons.CacheDir.CacheDir):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        print("INSTANCIATED %s" % str(type(self).__name__))

    @classmethod
    def copy_to_cache(cls, env, src, dst):
        print("MY_CUSTOM_CACHEDIR_CLASS1")
        super().copy_to_cache(env, src, dst)

class CustomCacheDir2(SCons.CacheDir.CacheDir):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        print("INSTANCIATED %s" % str(type(self).__name__))

    @classmethod
    def copy_to_cache(cls, env, src, dst):
        print("MY_CUSTOM_CACHEDIR_CLASS2")
        super().copy_to_cache(env, src, dst)

env = Environment(tools=[])
env.CacheDir('cache1', CustomCacheDir1)
env.CacheDir('cache2', CustomCacheDir2)

# two cachedirs were initialized, but the second one was the most recent
# and should remain in the cloned environment, even when we switch the
# original environment back. The cachedir2 should be the only copy_to_cache
# function we call.
cloned = env.Clone()
cloned.Command('file.out', 'file.in', Copy('$TARGET', '$SOURCE'))

env.CacheDir('cache1', CustomCacheDir1)

=== test/MSVC/msvc_fixture/SConstruct ===
# msvc_fixture's SConstruct

DefaultEnvironment(tools=[])
# TODO:  this is order-dependent (putting 'mssdk' second or third breaks),
# and ideally we shouldn't need to specify the tools= list anyway.
env = Environment(tools=['mssdk', 'msvc', 'mslink'])
env.Append(CCFLAGS='/DPCHDEF')
env['PDB'] = File('test.pdb')
env['PCHSTOP'] = 'StdAfx.h'
env['PCH'] = env.PCH('StdAfx.cpp')[0]
env.Program('test', ['test.cpp', env.RES('test.rc')], LIBS=['user32'])

env.Object('fast', 'foo.cpp')
env.Object('slow', 'foo.cpp', PCH=0)

=== test/Progress/multi_target_fixture/SConstruct ===
import SCons


class ProgressTest:

    def __call__(self, node):
        if node.get_state() == SCons.Node.executing:
            print(node)


env = Environment(tools=[])
env.Command(target=['out1.txt', 'out2.txt'], source=['in.txt'], action=Action(
    'echo $SOURCE > ${TARGETS[0]};echo $SOURCE > ${TARGETS[1]}', None))
Progress(ProgressTest())

=== test/SConscript/fixture/SConstruct ===
import SCons
from SCons.Warnings import _warningOut
import sys

DefaultEnvironment(tools=[])
# 1. call should succeed without deprecation warning
try:
    SConscript('missing/SConscript', must_exist=False)
except SCons.Errors.UserError as e:
    if _warningOut:
        _warningOut(e)
# 2. call should succeed with deprecation warning
try:
    SConscript('missing/SConscript')
except SCons.Errors.UserError as e:
    if _warningOut:
        _warningOut(e)

=== test/Scanner/Python/SConstruct ===
import sys

env = Environment(tools=['python'])

# Copy each file individually instead of copying the dir. This has the benefit
# of establishing nodes in-memory for each of the resulting files, which helps
# the scanner work correctly.
srcDir = env.Dir('to_be_copied')
for srcNode in srcDir.glob('*'):
    for destDir in [env.Dir('package1'), env.Dir('package2')]:
        env.Command(destDir.File(srcNode.name), srcNode,
                    Copy('$TARGET', '$SOURCE'))

# Don't set a dependency on the copy actions on purpose. Scanner should find
# the dependencies automatically.
env.Command('a.out', 'script.py', '$PYTHON $SOURCE $TARGET', PYTHON=sys.executable)

=== test/option/hash-format/SConstruct ===
import atexit
import sys

hash_format = GetOption('hash_format')
if not hash_format:
    # Override to SHA-256 to validate that override is effective
    hash_format = 'sha256'
    SetOption('hash_format', hash_format)

DefaultEnvironment(tools=[])
B = Builder(action = r'$PYTHON build.py $TARGETS $SOURCES')
env = Environment(tools=[], BUILDERS = { 'B' : B })
env['PYTHON'] = sys.executable
f1 = env.B(target = 'f1.out', source = 'f1.in')

def VerifyCsig():
    csig = f1[0].get_csig()
    if hash_format == 'md5':
        assert csig == 'fe06ae4170d4fead2c958439c738859e', csig
    elif hash_format == 'sha1':
        assert csig == 'efe5c6daa743540e9561934e3e18628b336013f7', csig
    elif hash_format == 'sha256':
        assert csig == 'a28bb79aa5ca8a5eb2dc5910a103d1a6312e79d73ed8054787cee78cc532a6aa', csig
    elif hash_format != 'testfailure':
        raise Exception('Hash format %s is not supported in '
                        'test/option/hash-format/SConstruct' % hash_format)
atexit.register(VerifyCsig)

=== debian/changelog ===
scons (4.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release:
    - fix content-timestamp decider for symlinks (closes: #981584).
  * Move binaries back to /usr (closes: #1020082).
  * Handle man pages correctly.
  * Suggest scons-doc on scons package (closes: #973301).
  * Update Standards-Version to 4.6.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 20 Sep 2022 17:35:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: scons
 Section: devel
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
  debhelper-compat (= 12),
  dh-python,
@@ -13,8 +12,9 @@
  biber <!nocheck>,
  clang <!nocheck>,
  gdc <!nocheck>,
+ python3-psutil <!nocheck>,
  ldc [amd64] <!nocheck>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://www.scons.org/
 Vcs-Git: https://salsa.debian.org/debian/scons.git
@@ -25,6 +25,7 @@
 Depends:
  ${python3:Depends},
  ${misc:Depends}
+Suggests: scons-doc
 Description: replacement for make
  SCons is a make replacement providing a range of enhanced features such
  as automated dependency generation and built in compilation cache
@@ -34,6 +35,7 @@
 
 Package: scons-doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Breaks: scons-doc (<< 4.0.1)
 Replaces: scons-doc (<< 4.0.1)

=== debian/rules ===
--- 
+++ 
@@ -17,11 +17,19 @@
 	cd $(CURDIR)/doc/user && python3 ../../scripts/scons.py
 
 override_dh_auto_install:
-	python3 setup.py install --prefix /usr --root '$(CURDIR)/debian/scons'
-	$(RM) -r debian/scons/usr/lib/python*/site-packages/SCons/Tool/docbook/
+	# setup.cfg contains bad path for man pages
+	cp -av $(CURDIR)/doc/man/*.1 $(CURDIR)
+	python3 setup.py install \
+		--prefix /usr \
+		--install-data=/usr/share/man/man1/ \
+		--root '$(CURDIR)/debian/scons'
+	mv $(CURDIR)/debian/scons/usr/local/bin/ $(CURDIR)/debian/scons/usr/
+	$(RM) -r debian/scons/usr/local/lib/python*/dist-packages/SCons/Tool/docbook/
 
 override_dh_auto_clean:
 	$(RM) -r .sconsign.dblite bootstrap build $$(find * -name __pycache__ -type d)
+	$(RM) $(CURDIR)/*.1
+	$(RM) $(CURDIR)/failed_tests.log
 	$(RM) -r $(CURDIR)/SCons.egg-info $(CURDIR)/.pybuild
 	# generated documentation
 	$(RM) $(CURDIR)/doc/man/.sconsign.dblite
@@ -71,6 +79,3 @@
 ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
 	python3 runtest.py --all --passed $(SCONS_FLAGS) || true
 endif
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## scons 4.5.2%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-python,
  python3-all (>= 3.5),
  fop,
@@ -14,7 +14,7 @@
  gdc <!nocheck>,
  python3-psutil <!nocheck>,
  ldc [amd64] <!nocheck>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.scons.org/
 Vcs-Git: https://salsa.debian.org/debian/scons.git

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$// \
https://github.com/SCons/scons/tags .*/v?(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
